Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Audible.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Audible.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Audible.pm	(revision 34921)
@@ -0,0 +1,317 @@
+#------------------------------------------------------------------------------
+# File:         Audible.pm
+#
+# Description:  Read metadata from Audible audio books
+#
+# Revisions:    2015/04/05 - P. Harvey Created
+#
+# References:   1) https://github.com/jteeuwen/audible
+#               2) https://code.google.com/p/pyaudibletags/
+#               3) http://wiki.multimedia.cx/index.php?title=Audible_Audio
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::Audible;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.02';
+
+sub ProcessAudible_meta($$$);
+sub ProcessAudible_cvrx($$$);
+
+%Image::ExifTool::Audible::Main = (
+    GROUPS => { 2 => 'Audio' },
+    NOTES => q{
+        ExifTool will extract any information found in the metadata dictionary of
+        Audible .AA files, even if not listed in the table below.
+    },
+    # tags found in the metadata dictionary (chunk 2)
+    pubdate    => { Name => 'PublishDate', Groups => { 2 => 'Time' } },
+    pub_date_start => { Name => 'PublishDateStart', Groups => { 2 => 'Time' } },
+    author     => { Name => 'Author',      Groups => { 2 => 'Author' } },
+    copyright  => { Name => 'Copyright',   Groups => { 2 => 'Author' } },
+    # also seen (ref PH):
+    # product_id, parent_id, title, provider, narrator, price, description,
+    # long_description, short_title, is_aggregation, title_id, codec, HeaderSeed,
+    # EncryptedBlocks, HeaderKey, license_list, CPUType, license_count, <12 hex digits>,
+    # parent_short_title, parent_title, aggregation_id, short_description, user_alias
+
+    # information extracted from other chunks
+    _chapter_count => { Name => 'ChapterCount' },       # from chunk 6
+    _cover_art => { # from chunk 11
+        Name => 'CoverArt',
+        Groups => { 2 => 'Preview' },
+        Binary => 1,
+    },
+);
+
+# 'tags' atoms observed in Audible .m4b audio books (ref PH)
+%Image::ExifTool::Audible::tags = (
+    GROUPS => { 0 => 'QuickTime', 2 => 'Audio' },
+    NOTES => 'Information found in "tags" atom of Audible M4B audio books.',
+    meta => {
+        Name => 'Audible_meta',
+        SubDirectory => { TagTable => 'Image::ExifTool::Audible::meta' },
+    },
+    cvrx => {
+        Name => 'Audible_cvrx',
+        SubDirectory => { TagTable => 'Image::ExifTool::Audible::cvrx' },
+    },
+    tseg => {
+        Name => 'Audible_tseg',
+        SubDirectory => { TagTable => 'Image::ExifTool::Audible::tseg' },
+    },
+);
+
+# 'meta' information observed in Audible .m4b audio books (ref PH)
+%Image::ExifTool::Audible::meta = (
+    PROCESS_PROC => \&ProcessAudible_meta,
+    GROUPS => { 0 => 'QuickTime', 2 => 'Audio' },
+    NOTES => 'Information found in Audible M4B "meta" atom.',
+    Album       => 'Album',
+    ALBUMARTIST => { Name => 'AlbumArtist', Groups => { 2 => 'Author' } },
+    Artist      => { Name => 'Artist',      Groups => { 2 => 'Author' } },
+    Comment     => 'Comment',
+    Genre       => 'Genre',
+    itunesmediatype => { Name => 'iTunesMediaType', Description => 'iTunes Media Type' },
+    SUBTITLE    => 'Subtitle',
+    Title       => 'Title',
+    TOOL        => 'CreatorTool',
+    Year        => { Name => 'Year', Groups => { 2 => 'Time' } },
+    track       => 'ChapterName', # (found in 'meta' of 'tseg' atom)
+);
+
+# 'cvrx' information observed in Audible .m4b audio books (ref PH)
+%Image::ExifTool::Audible::cvrx = (
+    PROCESS_PROC => \&ProcessAudible_cvrx,
+    GROUPS => { 0 => 'QuickTime', 2 => 'Audio' },
+    NOTES => 'Audible cover art information in M4B audio books.',
+    VARS => { NO_ID => 1 },
+    CoverArtType => 'CoverArtType',
+    CoverArt     => {
+        Name => 'CoverArt',
+        Groups => { 2 => 'Preview' },
+        Binary => 1,
+    },
+);
+
+# 'tseg' information observed in Audible .m4b audio books (ref PH)
+%Image::ExifTool::Audible::tseg = (
+    GROUPS => { 0 => 'QuickTime', 2 => 'Audio' },
+    tshd => {
+        Name => 'ChapterNumber',
+        Format => 'int32u',
+        ValueConv => '$val + 1',    # start counting from 1
+    },
+    meta => {
+        Name => 'Audible_meta2',
+        SubDirectory => { TagTable => 'Image::ExifTool::Audible::meta' },
+    },
+);
+
+#------------------------------------------------------------------------------
+# Process Audible 'meta' tags from M4B files (ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessAudible_meta($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dataPos = $$dirInfo{DataPos};
+    my $dirLen = length $$dataPt;
+    return 0 if $dirLen < 4;
+    my $num = Get32u($dataPt, 0);
+    $et->VerboseDir('Audible_meta', $num);
+    my $pos = 4;
+    my $index;
+    for ($index=0; $index<$num; ++$index) {
+        last if $pos + 3 > $dirLen;
+        my $unk = Get8u($dataPt, $pos);             # ? (0x80 or 0x00)
+        last unless $unk == 0x80 or $unk == 0x00;
+        my $len = Get16u($dataPt, $pos + 1);        # tag length
+        $pos += 3;
+        last if $pos + $len + 6 > $dirLen or not $len;
+        my $tag = substr($$dataPt, $pos, $len);     # tag ID
+        my $ver = Get16u($dataPt, $pos + $len);     # version?
+        last unless $ver == 0x0001;
+        my $size = Get32u($dataPt, $pos + $len + 2);# data size
+        $pos += $len + 6;
+        last if $pos + $size > $dirLen;
+        my $val = $et->Decode(substr($$dataPt, $pos, $size), 'UTF8');
+        unless ($$tagTablePtr{$tag}) {
+            my $name = Image::ExifTool::MakeTagName(($tag =~ /[a-z]/) ? $tag : lc($tag));
+            AddTagToTable($tagTablePtr, $tag, { Name => $name });
+        }
+        $et->HandleTag($tagTablePtr, $tag, $val,
+            DataPt  => $dataPt,
+            DataPos => $dataPos,
+            Start   => $pos,
+            Size    => $size,
+            Index   => $index,
+        );
+        $pos += $size;
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Process Audible 'cvrx' cover art atom from M4B files (ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessAudible_cvrx($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dataPos = $$dirInfo{DataPos};
+    my $dirLen = length $$dataPt;
+    return 0 if 0x0a > $dirLen;
+    my $len = Get16u($dataPt, 0x08);
+    return 0 if 0x0a + $len + 6 > $dirLen;
+    my $size = Get32u($dataPt, 0x0a + $len + 2);
+    return 0 if 0x0a + $len + 6 + $size > $dirLen;
+    $et->VerboseDir('Audible_cvrx', undef, $dirLen);
+    $et->HandleTag($tagTablePtr, 'CoverArtType', undef,
+        DataPt  => $dataPt,
+        DataPos => $dataPos,
+        Start   => 0x0a,
+        Size    => $len,
+    );
+    $et->HandleTag($tagTablePtr, 'CoverArt', undef,
+        DataPt  => $dataPt,
+        DataPos => $dataPos,
+        Start   => 0x0a + $len + 6,
+        Size    => $size,
+    );
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Read information from an Audible .AA file
+# Inputs: 0) ExifTool ref, 1) dirInfo ref
+# Returns: 1 on success, 0 if this wasn't a valid AA file
+sub ProcessAA($$)
+{
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my ($buff, $toc, $entry, $i);
+
+    # check magic number
+    return 0 unless $raf->Read($buff, 16) == 16 and $buff=~/^.{4}\x57\x90\x75\x36/s;
+    # check file size
+    if (defined $$et{VALUE}{FileSize}) {
+        # first 4 bytes of the file should be the filesize
+        unpack('N', $buff) == $$et{VALUE}{FileSize} or return 0;
+    }
+    $et->SetFileType();
+    SetByteOrder('MM');
+    my $bytes = 12 * Get32u(\$buff, 8); # table of contents size in bytes
+    $bytes > 0xc00 and $et->Warn('Invalid TOC'), return 1;
+    # read the table of contents
+    $raf->Read($toc, $bytes) == $bytes or $et->Warn('Truncated TOC'), return 1;
+    my $tagTablePtr = GetTagTable('Image::ExifTool::Audible::Main');
+    # parse table of contents (in $toc)
+    for ($entry=0; $entry<$bytes; $entry+=12) {
+        my $type = Get32u(\$toc, $entry);
+        next unless $type == 2 or $type == 6 or $type == 11;
+        my $offset = Get32u(\$toc, $entry + 4);
+        my $length = Get32u(\$toc, $entry + 8) or next;
+        $raf->Seek($offset, 0) or $et->Warn("Chunk $type seek error"), last;
+        if ($type == 6) {   # offset table
+            next if $length < 4 or $raf->Read($buff, 4) != 4; # only read the chapter count
+            $et->HandleTag($tagTablePtr, '_chapter_count', Get32u(\$buff, 0));
+            next;
+        }
+        # read the chunk
+        $length > 100000000 and $et->Warn("Chunk $type too big"), next;
+        $raf->Read($buff, $length) == $length or $et->Warn("Chunk $type read error"), last;
+        if ($type == 11) {  # cover art
+            next if $length < 8;
+            my $len = Get32u(\$buff, 0);
+            my $off = Get32u(\$buff, 4);
+            next if $off < $offset + 8 or $off - $offset + $len > $length;
+            $et->HandleTag($tagTablePtr, '_cover_art', substr($buff, $off-$offset, $len));
+            next;
+        }
+        # parse metadata dictionary (in $buff)
+        $length < 4 and $et->Warn('Bad dictionary'), next;
+        my $num = Get32u(\$buff, 0);
+        $num > 0x200 and $et->Warn('Bad dictionary count'), next;
+        my $pos = 4;    # dictionary starts immediately after count
+        require Image::ExifTool::HTML;  # (for UnescapeHTML)
+        $et->VerboseDir('Audible Metadata', $num);
+        for ($i=0; $i<$num; ++$i) {
+            my $tagPos = $pos + 9;                  # position of tag string
+            $tagPos > $length and $et->Warn('Truncated dictionary'), last;
+            # (1 unknown byte ignored at start of each dictionary entry)
+            my $tagLen = Get32u(\$buff, $pos + 1);  # tag string length
+            my $valLen = Get32u(\$buff, $pos + 5);  # value string length
+            my $valPos = $tagPos + $tagLen;         # position of value string
+            my $nxtPos = $valPos + $valLen;         # position of next entry
+            $nxtPos > $length and $et->Warn('Bad dictionary entry'), last;
+            my $tag = substr($buff, $tagPos, $tagLen);
+            my $val = substr($buff, $valPos, $valLen);
+            unless ($$tagTablePtr{$tag}) {
+                my $name = Image::ExifTool::MakeTagName($tag);
+                $name =~ s/_(.)/\U$1/g; # change from underscore-separated to mixed case
+                AddTagToTable($tagTablePtr, $tag, { Name => $name });
+            }
+            # unescape HTML character references and convert from UTF-8
+            $val = $et->Decode(Image::ExifTool::HTML::UnescapeHTML($val), 'UTF8');
+            $et->HandleTag($tagTablePtr, $tag, $val,
+                DataPos => $offset,
+                DataPt  => \$buff,
+                Start   => $valPos,
+                Size    => $valLen,
+                Index   => $i,
+            );
+            $pos = $nxtPos; # step to next dictionary entry
+        }
+    }
+    return 1;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::Audible - Read meta information from Audible audio books
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to read meta
+information from Audible audio books.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<https://github.com/jteeuwen/audible>
+
+=item L<https://code.google.com/p/pyaudibletags/>
+
+=item L<http://wiki.multimedia.cx/index.php?title=Audible_Audio>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/Audible Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BMP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BMP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BMP.pm	(revision 34921)
@@ -8,4 +8,5 @@
 # References:   1) http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html
 #               2) http://www.fourcc.org/rgb.php
+#               3) https://msdn.microsoft.com/en-us/library/dd183381(v=vs.85).aspx
 #------------------------------------------------------------------------------
 
@@ -16,5 +17,19 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.07';
+$VERSION = '1.09';
+
+# conversions for fixed-point 2.30 format values
+my %fixed2_30 = (
+    ValueConv => q{
+        my @a = split ' ', $val;
+        $_ /= 0x40000000 foreach @a;
+        "@a";
+    },
+    PrintConv => q{
+        my @a = split ' ', $val;
+        $_ = sprintf('%.6f', $_) foreach @a;
+        "@a";
+    },
+);
 
 # BMP chunks
@@ -26,11 +41,19 @@
         of image related information.
     },
-    # 0 => size of bitmap structure:
-    #        12  bytes => 'OS/2 V1',
-    #        40  bytes => 'Windows V3',
-    #        64  bytes => 'OS/2 V2',
-    #        68  bytes => some bitmap structure in AVI videos
-    #        108 bytes => 'Windows V4',
-    #        124 bytes => 'Windows V5',
+    0 => {
+        Name => 'BMPVersion',
+        Format => 'int32u',
+        Notes => q{
+            this is actually the size of the BMP header, but used to determine the BMP
+            version
+        },
+        RawConv => '$$self{BMPVersion} = $val',
+        PrintConv => {
+            40  => 'Windows V3',
+            68  => 'AVI BMP structure?', #PH (seen in AVI movies from some Casio and Nikon cameras)
+            108 => 'Windows V4',
+            124 => 'Windows V5',
+        },
+    },
     4 => {
         Name => 'ImageWidth',
@@ -45,4 +68,5 @@
         Name => 'Planes',
         Format => 'int16u',
+        # values: 0,1,4,8,16,24,32
     },
     14 => {
@@ -53,4 +77,5 @@
         Name => 'Compression',
         Format => 'int32u',
+        RawConv => '$$self{BMPCompression} = $val',
         # (formatted as string[4] for some values in AVI images)
         ValueConv => '$val > 256 ? unpack("A4",pack("V",$val)) : $val',
@@ -74,4 +99,5 @@
         Name => 'ImageLength',
         Format => 'int32u',
+        RawConv => '$$self{BMPImageLength} = $val',
     },
     24 => {
@@ -91,6 +117,97 @@
         Name => 'NumImportantColors',
         Format => 'int32u',
+        Hook => '$varSize += $size if $$self{BMPVersion} == 68', # (the rest is invalid for AVI BMP's)
         PrintConv => '$val ? $val : "All"',
     },
+    40 => {
+        Name => 'RedMask',
+        Format => 'int32u',
+        PrintConv => 'sprintf("0x%.8x",$val)',
+    },
+    44 => {
+        Name => 'GreenMask',
+        Format => 'int32u',
+        PrintConv => 'sprintf("0x%.8x",$val)',
+    },
+    48 => {
+        Name => 'BlueMask',
+        Format => 'int32u',
+        PrintConv => 'sprintf("0x%.8x",$val)',
+    },
+    52 => {
+        Name => 'AlphaMask',
+        Format => 'int32u',
+        PrintConv => 'sprintf("0x%.8x",$val)',
+    },
+    56 => {
+        Name => 'ColorSpace',
+        Format => 'undef[4]',
+        RawConv => '$$self{BMPColorSpace} = $val =~ /\0/ ? Get32u(\$val, 0) : pack("N",unpack("V",$val))',
+        PrintConv => {
+            0 => 'Calibrated RGB',
+            1 => 'Device RGB',
+            2 => 'Device CMYK',
+            LINK => 'Linked Color Profile',
+            MBED => 'Embedded Color Profile',
+            sRGB => 'sRGB',
+            'Win ' => 'Windows Color Space',
+        },
+    },
+    60 => {
+        Name => 'RedEndpoint',
+        Condition => '$$self{BMPColorSpace} eq "0"',
+        Format => 'int32u[3]',
+        %fixed2_30,
+    },
+    72 => {
+        Name => 'GreenEndpoint',
+        Condition => '$$self{BMPColorSpace} eq "0"',
+        Format => 'int32u[3]',
+        %fixed2_30,
+    },
+    84 => {
+        Name => 'BlueEndpoint',
+        Condition => '$$self{BMPColorSpace} eq "0"',
+        Format => 'int32u[3]',
+        %fixed2_30,
+    },
+    96 => {
+        Name => 'GammaRed',
+        Condition => '$$self{BMPColorSpace} eq "0"',
+        Format => 'fixed32u',
+    },
+    100 => {
+        Name => 'GammaGreen',
+        Condition => '$$self{BMPColorSpace} eq "0"',
+        Format => 'fixed32u',
+    },
+    104 => {
+        Name => 'GammaBlue',
+        Condition => '$$self{BMPColorSpace} eq "0"',
+        Format => 'fixed32u',
+    },
+    108 => {
+        Name => 'RenderingIntent',
+        Format => 'int32u',
+        PrintConv => {
+            1 => 'Graphic (LCS_GM_BUSINESS)',
+            2 => 'Proof (LCS_GM_GRAPHICS)',
+            4 => 'Picture (LCS_GM_IMAGES)',
+            8 => 'Absolute Colorimetric (LCS_GM_ABS_COLORIMETRIC)',
+        },
+    },
+    112 => {
+        Name => 'ProfileDataOffset',
+        Condition => '$$self{BMPColorSpace} eq "LINK" or $$self{BMPColorSpace} eq "MBED"',
+        Format => 'int32u',
+        RawConv => '$$self{BMPProfileOffset} = $val',
+    },
+    116 => {
+        Name => 'ProfileSize',
+        Condition => '$$self{BMPColorSpace} eq "LINK" or $$self{BMPColorSpace} eq "MBED"',
+        Format => 'int32u',
+        RawConv => '$$self{BMPProfileSize} = $val',
+    },
+    # 120 - reserved
 );
 
@@ -100,9 +217,33 @@
     GROUPS => { 0 => 'File', 1 => 'File', 2 => 'Image' },
     NOTES => 'Information extracted from OS/2-format BMP images.',
-    # 0 => size of bitmap structure (12)
+    0 => {
+        Name => 'BMPVersion',
+        Format => 'int32u',
+        Notes => 'again, the header size is used to determine the BMP version',
+        PrintConv => {
+            12  => 'OS/2 V1',
+            64  => 'OS/2 V2',
+        },
+    },
     4  => { Name => 'ImageWidth',  Format => 'int16u' },
     6  => { Name => 'ImageHeight', Format => 'int16u' },
     8  => { Name => 'Planes',      Format => 'int16u' },
     10 => { Name => 'BitDepth',    Format => 'int16u' },
+);
+
+%Image::ExifTool::BMP::Extra = (
+    GROUPS => { 0 => 'File', 1 => 'File', 2 => 'Image' },
+    NOTES => 'Extra information extracted from some BMP images.',
+    VARS => { NO_ID => 1 },
+    LinkedProfileName => { },
+    ICC_Profile => { SubDirectory => { TagTable => 'Image::ExifTool::ICC_Profile::Main' } },
+    EmbeddedJPG => {
+        Groups => { 2 => 'Preview' },
+        Binary => 1,
+    },
+    EmbeddedPNG => {
+        Groups => { 2 => 'Preview' },
+        Binary => 1,
+    },
 );
 
@@ -113,5 +254,5 @@
 sub ProcessBMP($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my ($buff, $tagTablePtr);
@@ -122,7 +263,11 @@
     SetByteOrder('II');
     my $len = Get32u(\$buff, 14);
-    return 0 unless $len == 12 or $len >= 40;
+    # len = v1:12, v4:108, v5:124
+    return 0 unless $len == 12 or $len == 16 or ($len >= 40 and $len < 1000000);
     return 0 unless $raf->Seek(-4, 1) and $raf->Read($buff, $len) == $len;
-    $exifTool->SetFileType();   # set the FileType tag
+    $et->SetFileType();   # set the FileType tag
+#
+# process the BMP header
+#
     my %dirInfo = (
         DataPt => \$buff,
@@ -130,10 +275,43 @@
         DirLen => length($buff),
     );
-    if ($len == 12) {   # old OS/2 format BMP
+    if ($len == 12 or $len == 16 or $len == 64) {   # old OS/2 format BMP
         $tagTablePtr = GetTagTable('Image::ExifTool::BMP::OS2');
     } else {
         $tagTablePtr = GetTagTable('Image::ExifTool::BMP::Main');
     }
-    $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+    $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
+#
+# extract any embedded images
+#
+    my $extraTable = GetTagTable('Image::ExifTool::BMP::Extra');
+    if ($$et{BMPCompression} and $$et{BMPImageLength} and
+        ($$et{BMPCompression} == 4 or $$et{BMPCompression} == 5))
+    {
+        my $tag = $$et{BMPCompression} == 4 ? 'EmbeddedJPG' : 'EmbeddedPNG';
+        my $val = $et->ExtractBinary($raf->Tell(), $$et{BMPImageLength}, $tag);
+        if ($val) {
+            $et->HandleTag($extraTable, $tag, $val);
+        }
+    }
+#
+# process profile data if it exists (v5 header only)
+#
+    if ($len == 124 and $$et{BMPProfileOffset}) {
+        my $pos = $$et{BMPProfileOffset} + 14;  # (note the 14-byte shift!)
+        my $size = $$et{BMPProfileSize};
+        if ($raf->Seek($pos, 0) and $raf->Read($buff, $size) == $size) {
+            my $tag;
+            if ($$et{BMPColorSpace} eq 'LINK') {
+                $buff =~ s/\0+$//;  # remove null terminator(s)
+                $buff = $et->Decode($buff, 'Latin'); # convert from Latin
+                $tag = 'LinkedProfileName';
+            } else {
+                $tag = 'ICC_Profile';
+            }
+            $et->HandleTag($extraTable, $tag => $buff, Size => $size, DataPos => $pos);
+        } else {
+            $et->Warn('Error loading profile data', 1);
+        }
+    }
     return 1;
 }
@@ -158,5 +336,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -169,4 +347,8 @@
 =item L<http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html>
 
+=item L<http://www.fourcc.org/rgb.php>
+
+=item L<https://msdn.microsoft.com/en-us/library/dd183381(v=vs.85).aspx>
+
 =back
 
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BPG.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BPG.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BPG.pm	(revision 34921)
@@ -0,0 +1,253 @@
+#------------------------------------------------------------------------------
+# File:         BPG.pm
+#
+# Description:  Read BPG meta information
+#
+# Revisions:    2016-07-05 - P. Harvey Created
+#
+# References:   1) http://bellard.org/bpg/
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::BPG;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.01';
+
+# BPG information
+%Image::ExifTool::BPG::Main = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'File', 1 => 'File', 2 => 'Image' },
+    NOTES => q{
+        The information listed below is extracted from BPG (Better Portable
+        Graphics) images.  See L<http://bellard.org/bpg/> for the specification.
+    },
+    4 => {
+        Name => 'PixelFormat',
+        Format => 'int16u',
+        Mask => 0xe000,
+        PrintConv => {
+            0 => 'Grayscale',
+            1 => '4:2:0 (chroma at 0.5, 0.5)',
+            2 => '4:2:2 (chroma at 0.5, 0)',
+            3 => '4:4:4',
+            4 => '4:2:0 (chroma at 0, 0.5)',
+            5 => '4:2:2 (chroma at 0, 0)',
+        },
+    },
+    4.1 => {
+        Name => 'Alpha',
+        Format => 'int16u',
+        Mask => 0x1004,
+        BitShift => 0,
+        PrintHex => 1,
+        PrintConv => {
+            0x0000 => 'No Alpha Plane',
+            0x1000 => 'Alpha Exists (color not premultiplied)',
+            0x1004 => 'Alpha Exists (color premultiplied)',
+            0x0004 => 'Alpha Exists (W color component)',
+        },
+    },
+    4.2 => {
+        Name => 'BitDepth',
+        Format => 'int16u',
+        Mask => 0x0f00,
+        ValueConv => '$val + 8',
+    },
+    4.3 => {
+        Name => 'ColorSpace',
+        Format => 'int16u',
+        Mask => 0x00f0,
+        PrintConv => {
+            0 => 'YCbCr (BT 601)',
+            1 => 'RGB',
+            2 => 'YCgCo',
+            3 => 'YCbCr (BT 709)',
+            4 => 'YCbCr (BT 2020)',
+            5 => 'BT 2020 Constant Luminance',
+        },
+    },
+    4.4 => {
+        Name => 'Flags',
+        Format => 'int16u',
+        Mask => 0x000b,
+        PrintConv => { BITMASK => {
+            0 => 'Animation',
+            1 => 'Limited Range',
+            3 => 'Extension Present',
+        }},
+    },
+    6 => { Name => 'ImageWidth',    Format => 'var_ue7' },
+    7 => { Name => 'ImageHeight',   Format => 'var_ue7' },
+    # length of image data or 0 to EOF
+    # (must be decoded so we know where the extension data starts)
+    8 => { Name => 'ImageLength',   Format => 'var_ue7' },
+);
+
+%Image::ExifTool::BPG::Extensions = (
+    GROUPS => { 0 => 'File', 1 => 'File', 2 => 'Image' },
+    VARS => { ALPHA_FIRST => 1 },
+    1 => {
+        Name => 'EXIF',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Exif::Main',
+            ProcessProc => \&Image::ExifTool::ProcessTIFF,
+        },
+    },
+    2 => {
+        Name => 'ICC_Profile',
+        SubDirectory => { TagTable => 'Image::ExifTool::ICC_Profile::Main' },
+    },
+    3 => {
+        Name => 'XMP',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::Main' },
+    },
+    4 => {
+        Name => 'ThumbnailBPG',
+        Binary => 1,
+    },
+    5 => {
+        Name => 'AnimationControl',
+        Binary => 1,
+        Unknown => 1,
+    },
+);
+
+#------------------------------------------------------------------------------
+# Get ue7 integer from binary data (max 32 bits)
+# Inputs: 0) data ref, 1) location in data (undef for 0)
+# Returns: 0) ue7 as integer or undef on error, 1) length of ue7 in bytes
+sub Get_ue7($;$)
+{
+    my $dataPt = shift;
+    my $pos = shift || 0;
+    my $size = length $$dataPt;
+    my $val = 0;
+    my $i;
+    for ($i=0; ; ) {
+        return() if $pos+$i >= $size or $i >= 5;
+        my $byte = Get8u($dataPt, $pos + $i);
+        $val = ($val << 7) | ($byte & 0x7f);
+        unless ($byte & 0x80) {
+            return() if $i == 4 and $byte & 0x70;   # error if bits 32-34 are set
+            last;   # this was the last byte
+        }
+        return() if $i == 0 and $byte == 0x80;      # error if first byte is 0x80
+        ++$i;       # step to the next byte
+    }
+    return($val, $i+1);
+}
+
+#------------------------------------------------------------------------------
+# Extract EXIF information from a BPG image
+# Inputs: 0) ExifTool object reference, 1) dirInfo reference
+# Returns: 1 on success, 0 if this wasn't a valid BPG file
+sub ProcessBPG($$)
+{
+    local $_;
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my ($buff, $size, $n, $len, $pos);
+
+    # verify this is a valid BPG file
+    return 0 unless $raf->Read($buff, 21) == 21; # (21 bytes is maximum header length)
+    return 0 unless $buff =~ /^BPG\xfb/;
+    $et->SetFileType();   # set the FileType tag
+
+    SetByteOrder('MM');
+    my %dirInfo = (
+        DataPt   => \$buff,
+        DirStart => 0,
+        DirLen   => length($buff),
+        VarFormatData => [ ],
+    );
+    $et->ProcessDirectory(\%dirInfo, GetTagTable('Image::ExifTool::BPG::Main'));
+
+    return 1 unless $$et{VALUE}{Flags} & 0x0008;  # all done unless extension flag is set
+
+    # add varSize from last entry in VarFormatData to determine
+    # the current read position in the file
+    my $dataPos = 9 + $dirInfo{VarFormatData}[-1][1];
+    # read extension length
+    unless ($raf->Seek($dataPos, 0) and $raf->Read($buff, 5) == 5) {
+        $et->Warn('Missing BPG extension data');
+        return 1;
+    }
+    ($size, $n) = Get_ue7(\$buff);
+    defined $size or $et->Warn('Corrupted BPG extension length'), return 1;
+    $dataPos += $n;
+    $size > 10000000 and $et->Warn('BPG extension is too large'), return 1;
+    unless ($raf->Seek($dataPos, 0) and $raf->Read($buff, $size) == $size) {
+        $et->Warn('Truncated BPG extension');
+        return 1;
+    }
+    my $tagTablePtr = GetTagTable('Image::ExifTool::BPG::Extensions');
+    # loop through the individual extensions
+    for ($pos=0; $pos<$size; $pos+=$len) {
+        my $type = Get8u(\$buff, $pos);
+        # get length of this extension
+        ($len, $n) = Get_ue7(\$buff, ++$pos);
+        defined $len or $et->Warn('Corrupted BPG extension'), last;
+        $pos += $n; # point to start of data for this extension
+        $pos + $len > $size and $et->Warn('Invalid BPG extension size'), last;
+        $$tagTablePtr{$type} or $et->Warn("Unrecognized BPG extension $type ($len bytes)", 1), next;
+        # libbpg (in my opinion) incorrectly copies the padding byte after the
+        # "EXIF\0" APP1 header to the start of the BPG EXIF extension, so issue a
+        # minor warning and ignore the padding if we find it before the TIFF header
+        if ($type == 1 and $len > 3 and substr($buff,$pos,3)=~/^.(II|MM)/s) {
+            $et->Warn("Ignored extra byte at start of EXIF extension", 1);
+            ++$pos;
+            --$len;
+        }
+        $et->HandleTag($tagTablePtr, $type, undef,
+            DataPt  => \$buff,
+            DataPos => $dataPos,
+            Start   => $pos,
+            Size    => $len,
+            Parent  => 'BPG',
+        );
+    }
+    return 1;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::BPG - Read BPG meta information
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to read BPG
+(Better Portable Graphics) images.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<http://bellard.org/bpg/>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/BPG Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BZZ.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BZZ.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BZZ.pm	(revision 34921)
@@ -446,5 +446,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 Copyright 2002, Leon Bottou and Yann Le Cun
 Copyright 2001, AT&T
